Loading...
Searching...
No Matches
Ogre::NumericAnimationTrack Class Reference
Core » Animation

Specialised AnimationTrack for dealing with generic animable values. More...

`#include <OgreAnimationTrack.h>`

Inheritance diagram for Ogre::NumericAnimationTrack:
[legend]

## Public Member Functions

| NumericAnimationTrack (Animation *parent, unsigned short handle, const AnimableValuePtr &target)
| Constructor, associates with an AnimableValue.
NumericAnimationTrack * | _clone (Animation *newParent) const
| Clone this track (internal use only).
void | apply (const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f) override
| Applies an animation track to the designated target.
void | applyToAnimable (const AnimableValuePtr &anim, const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f)
| Applies an animation track to a given animable value.
virtual NumericKeyFrame * | createNumericKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
const AnimableValuePtr & | getAssociatedAnimable (void) const
| Returns a pointer to the associated animable object (if any).
void | getInterpolatedKeyFrame (const TimeIndex &timeIndex, KeyFrame *kf) const override
| Gets a KeyFrame object which contains the interpolated transforms at the time index specified.
NumericKeyFrame * | getNumericKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index.
void | setAssociatedAnimable (const AnimableValuePtr &val)
| Sets the associated animable object which will be automatically affected by calls to 'apply'.
Public Member Functions inherited from Ogre::AnimationTrack
| AnimationTrack (Animation *parent, unsigned short handle)
| Constructor.
virtual | ~AnimationTrack ()
virtual void | _applyBaseKeyFrame (const KeyFrame *base)
| Internal method to re-base the keyframes relative to a given keyframe.
virtual void | _buildKeyFrameIndexMap (const std::vector< Real > &keyFrameTimes)
| Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.
virtual void | _collectKeyFrameTimes (std::vector< Real > &keyFrameTimes)
| Internal method to collect keyframe times, in unique, ordered format.
virtual void | _keyFrameDataChanged (void) const
| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.
virtual KeyFrame * | createKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
unsigned short | getHandle (void) const
| Get the handle associated with this track.
KeyFrame * | getKeyFrame (size_t index) const
| Returns the KeyFrame at the specified index.
float | getKeyFramesAtTime (const TimeIndex &timeIndex, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const
| Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.
size_t | getNumKeyFrames (void) const
| Returns the number of keyframes in this animation.
Animation * | getParent () const
| Returns the parent Animation object for this track.
virtual bool | hasNonZeroKeyFrames (void) const
| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.
virtual void | optimise (void)
| Optimise the current track by removing any duplicate keyframes.
void | removeAllKeyFrames (void)
| Removes all the KeyFrames from this track.
virtual void | removeKeyFrame (unsigned short index)
| Removes a KeyFrame by it's index.
virtual void | setListener (Listener *l)
| Set a listener for this track.

## Detailed Description

Specialised AnimationTrack for dealing with generic animable values.

## Constructor & Destructor Documentation

## NumericAnimationTrack()

Ogre::NumericAnimationTrack::NumericAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | const AnimableValuePtr & | target )

Constructor, associates with an AnimableValue.

Referenced by _clone().

## Member Function Documentation

## createNumericKeyFrame()

virtual NumericKeyFrame * Ogre::NumericAnimationTrack::createNumericKeyFrame | ( | Real | timePos | ) |

virtual

Creates a new KeyFrame and adds it to this animation at the given time index.

It is better to create KeyFrames in time order.

Parameters

  timePos | The time from which this KeyFrame will apply.

## getInterpolatedKeyFrame()

void Ogre::NumericAnimationTrack::getInterpolatedKeyFrame | ( | const TimeIndex & | timeIndex,
|  | KeyFrame * | kf ) const

override virtual

Gets a KeyFrame object which contains the interpolated transforms at the time index specified.

The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'.

Parameters

  timeIndex | The time (in relation to the whole animation sequence)
  kf | Keyframe object to store results

Implements Ogre::AnimationTrack.

## apply()

void Ogre::NumericAnimationTrack::apply | ( | const TimeIndex & | timeIndex,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )

override virtual

Applies an animation track to the designated target.

Parameters

  timeIndex | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

Implements Ogre::AnimationTrack.

## applyToAnimable()

void Ogre::NumericAnimationTrack::applyToAnimable | ( | const AnimableValuePtr & | anim,
|  | const TimeIndex & | timeIndex,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )

Applies an animation track to a given animable value.

Parameters

  anim | The AnimableValue to which to apply the animation
  timeIndex | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

## getAssociatedAnimable()

const AnimableValuePtr & Ogre::NumericAnimationTrack::getAssociatedAnimable | ( | void |  | ) | const

inline

Returns a pointer to the associated animable object (if any).

## setAssociatedAnimable()

void Ogre::NumericAnimationTrack::setAssociatedAnimable | ( | const AnimableValuePtr & | val | ) |

inline

Sets the associated animable object which will be automatically affected by calls to 'apply'.

## getNumericKeyFrame()

NumericKeyFrame * Ogre::NumericAnimationTrack::getNumericKeyFrame | ( | unsigned short | index | ) | const

Returns the KeyFrame at the specified index.

## _clone()

NumericAnimationTrack * Ogre::NumericAnimationTrack::_clone | ( | Animation * | newParent | ) | const

Clone this track (internal use only).

References NumericAnimationTrack().

The documentation for this class was generated from the following file:

- OgreAnimationTrack.h